#ifndef BASE_DUMPER_H
#define BASE_DUMPER_H

#ifdef WIN32

class Dumper {
public:

	Dumper() {reset();}
	~Dumper() {shutdown();}

	void init();
	void shutdown();
	void resize(int x, int y, int w, int h);
	void dump();	//dump the current framebuffer content

protected:
	int x,y,w,h;
	char *buf;
	int count;

	void reset();
	int writeBitmap(char *name, char *buf, unsigned width, unsigned height);
};


#else
class Dumper {
public:
	bool init() { return true; }
	void shutdown() {}
	void resize(int x, int y, int w, int h) {}
	void dump() {}
};
#endif

#endif //BASE_DUMPER_H
