#ifndef BASE_OPENGL_EXTS_H
#define BASE_OPENGL_EXTS_H

#include "system/gl.h"

//well this method isn't working
//because -- if you do this load-before-glext / load-after-glext thing then
//you can only do it once -- dont try to include two headers that pull that technique
//once the first one loads glext then the whole thing is botched
//so either do ALLL your glext loading in one place
//or use glew
//or ... test it by WIN32 .. because windows sucks and good thing only it does, makes this easier to special-case

#ifdef WIN32

//#ifndef GL_ARB_multitexture
#define LOAD_ARB_multitexture
//#endif	//GL_ARB_multitexture

//#ifndef GL_ARB_point_parameters
#define LOAD_ARB_point_parameters
//#endif	//GL_ARB_point_parameters

//#ifndef GL_EXT_framebuffer_object
#define LOAD_EXT_framebuffer_object
//#endif	//GL_EXT_framebuffer_object

#define LOAD_ARB_vertex_buffer_object

//this one isnt showing up on windows or mac ...
//mac has gl 1.2 so it has glTexImage3D up front.  no need for the ext version.  i wonder if there's a dif ...
//#ifndef GL_EXT_texture3D
#define LOAD_EXT_texture3D
//#endif

#define LOAD_ARB_draw_buffers

#define LOAD_ARB_texture_non_power_of_two

#endif

//the one and only, official opengl extension header
#include "glext.h"

//some useful ones that slipped by glext (... or my version is outdated ...)
#ifndef GL_RGBA_FLOAT32_APPLE
#define GL_RGBA_FLOAT32_APPLE 0x8814
#endif
#ifndef GL_RGB_FLOAT32_APPLE
#define GL_RGB_FLOAT32_APPLE 0x8815
#endif
#ifndef GL_ALPHA_FLOAT32_APPLE
#define GL_ALPHA_FLOAT32_APPLE 0x8816
#endif
#ifndef GL_INTENSITY_FLOAT32_APPLE 
#define GL_INTENSITY_FLOAT32_APPLE 0x8817
#endif
#ifndef GL_LUMINANCE_FLOAT32_APPLE
#define GL_LUMINANCE_FLOAT32_APPLE 0x8818
#endif

//my one entry function
void init_ext();

//useful for the func/name macros:
#define GLEXT_ECHOPARAM_ARB(x)		&x##ARB, #x "ARB"
#define GLEXT_ECHOPARAM(x)			&x, #x

//after 'ext', expect <funcptr> <name> . . . (does va_list keep track of the count?)
//terminates on null
//returns -1 on success, -2 if the ext is not found, or # for the index of the failed arg on fail
int load_ext(const char *ext,  ...);

//returns true or false if it finds this in the string
bool gl_hasExt(const char *ext);

// GL_ARB_multitexture

extern bool								found_GL_ARB_multitexture;
#ifdef LOAD_ARB_multitexture
extern PFNGLMULTITEXCOORD1DVARBPROC		glMultiTexCoord1dvARB;
extern PFNGLMULTITEXCOORD2DVARBPROC		glMultiTexCoord2dvARB;
extern PFNGLMULTITEXCOORD3DVARBPROC		glMultiTexCoord3dvARB;
extern PFNGLMULTITEXCOORD4DVARBPROC		glMultiTexCoord4dvARB;
extern PFNGLMULTITEXCOORD1DARBPROC		glMultiTexCoord1dARB;
extern PFNGLMULTITEXCOORD2DARBPROC		glMultiTexCoord2dARB;
extern PFNGLMULTITEXCOORD3DARBPROC		glMultiTexCoord3dARB;
extern PFNGLMULTITEXCOORD4DARBPROC		glMultiTexCoord4dARB;
extern PFNGLMULTITEXCOORD2FARBPROC		glMultiTexCoord2fARB;
extern PFNGLMULTITEXCOORD2FVARBPROC		glMultiTexCoord2fvARB;
extern PFNGLMULTITEXCOORD3FARBPROC		glMultiTexCoord3fARB;
extern PFNGLMULTITEXCOORD3FVARBPROC		glMultiTexCoord3fvARB;
extern PFNGLMULTITEXCOORD4FPROC			glMultiTexCoord4fARB;
extern PFNGLACTIVETEXTUREARBPROC		glActiveTextureARB;
extern PFNGLCLIENTACTIVETEXTUREARBPROC	glClientActiveTextureARB;
#endif //LOAD_ARB_multitexture

extern bool								found_GL_EXT_framebuffer_object;
#ifdef LOAD_EXT_framebuffer_object
extern PFNGLBINDFRAMEBUFFEREXTPROC			glBindFramebufferEXT;
extern PFNGLBINDRENDERBUFFEREXTPROC			glBindRenderbufferEXT;
extern PFNGLCHECKFRAMEBUFFERSTATUSEXTPROC	glCheckFramebufferStatusEXT;
extern PFNGLDELETEFRAMEBUFFERSEXTPROC		glDeleteFramebuffersEXT;
extern PFNGLDELETERENDERBUFFERSEXTPROC		glDeleteRenderbuffersEXT;
extern PFNGLFRAMEBUFFERTEXTURE1DEXTPROC		glFramebufferTexture1DEXT;
extern PFNGLFRAMEBUFFERTEXTURE2DEXTPROC		glFramebufferTexture2DEXT;
extern PFNGLFRAMEBUFFERTEXTURE3DEXTPROC		glFramebufferTexture3DEXT;
extern PFNGLGENFRAMEBUFFERSEXTPROC			glGenFramebuffersEXT;
extern PFNGLGENERATEMIPMAPEXTPROC			glGenerateMipmapEXT;		//this isnt a fbo call is it?
extern PFNGLGENRENDERBUFFERSEXTPROC			glGenRenderbuffersEXT;
extern PFNGLISFRAMEBUFFEREXTPROC			glIsFramebufferEXT;
extern PFNGLISRENDERBUFFEREXTPROC			glIsRenderbufferEXT;
extern PFNGLRENDERBUFFERSTORAGEEXTPROC		glRenderbufferStorageEXT;
extern PFNGLFRAMEBUFFERRENDERBUFFEREXTPROC	glFramebufferRenderbufferEXT;
#endif	//LOAD_EXT_framebuffer_object

extern bool								found_GL_ARB_vertex_buffer_object;
#ifdef LOAD_ARB_vertex_buffer_object
extern PFNGLBINDBUFFERARBPROC				glBindBufferARB;
extern PFNGLDELETEBUFFERSARBPROC			glDeleteBuffersARB;
extern PFNGLGENBUFFERSARBPROC				glGenBuffersARB;
extern PFNGLISBUFFERARBPROC					glIsBufferARB;
extern PFNGLBUFFERDATAARBPROC				glBufferDataARB;
extern PFNGLBUFFERSUBDATAARBPROC			glBufferSubDataARB;
extern PFNGLGETBUFFERSUBDATAARBPROC			glGetBufferSubDataARB;
extern PFNGLMAPBUFFERARBPROC				glMapBufferARB;
extern PFNGLUNMAPBUFFERARBPROC				glUnmapBufferARB;
extern PFNGLGETBUFFERPARAMETERIVARBPROC		glGetBufferParameterivARB;
extern PFNGLGETBUFFERPOINTERVARBPROC		glGetBufferPointervARB;
#endif	//LOAD_ARB_vertex_buffer_object

extern bool								found_GL_EXT_texture3D;
#ifdef LOAD_EXT_texture3D
extern PFNGLTEXIMAGE3DEXTPROC			glTexImage3DEXT;		//how does this work with 1.2 glTexImage3D?
#endif //LOAD_EXT_texture3D

// GL_ARB_texture_cube_map

extern bool								found_GL_ARB_texture_cube_map;

// GL_ARB_texture_env_add

extern bool								found_GL_ARB_texture_env_add;

// GL_EXT_separate_specular_color

extern bool								found_GL_EXT_separate_specular_color;

// GL_SGIS_generate_mipmap

extern bool								found_GL_SGIS_generate_mipmap;

// GL_ARB_combine

extern bool								found_GL_ARB_texture_env_combine;

//	GL_EXT_point_parameters

#if 0	//why arent point parameters working?
extern bool								found_GL_ARB_point_parameters;
#ifdef GL_ARB_point_parameters
extern PFNGLPOINTPARAMETERFARBPROC		glPointParameterfARB;
extern PFNGLPOINTPARAMETERFVARBPROC		glPointParameterfvARB;
#endif //GL_ARB_point_parameters
#endif

#if 0	//same with draw range elements and everything else ...
extern bool								found_GL_EXT_draw_range_elements;
extern PFNGLDRAWRANGEELEMENTSPROC		glDrawRangeElements;

extern bool								found_GL_EXT_compiled_vertex_array;
extern PFNGLLOCKARRAYSEXTPROC			glLockArraysEXT;
extern PFNGLUNLOCKARRAYSEXTPROC			glUnlockArraysEXT;
#endif

extern bool								found_GL_ARB_draw_buffers;
#ifdef LOAD_ARB_draw_buffers
extern PFNGLDRAWBUFFERSARBPROC			glDrawBuffersARB;
#endif

extern bool								found_GL_ARB_texture_non_power_of_two;

#endif